## votca-xtp 1.6.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(votca-xtp)


set(PROJECT_VERSION "1.6.4")
set(PROJECT_CONTACT "bugs@votca.org")
string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
if (NOT ${SOVERSION} MATCHES "[1-9]+")
  message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")
endif (NOT ${SOVERSION} MATCHES "[1-9]+")

# Cmake modules/macros are in a subdirectory to keep this file cleaner
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
  #Release comes with -O3 by default
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
if(CMAKE_BUILD_TYPE STREQUAL Debug)
  add_definitions(-DDEBUG)
endif()

enable_language(CXX)

######################################################################
# compiler tests
# these need ot be done early (before further tests).
#####################################################################

include(CheckCXXCompilerFlag)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF) #...without compiler extensions like gnu++11

find_package(OpenMP)
if (OPENMP_FOUND)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()

########################################################################
# User input options                                                   #
########################################################################

find_package(LIBXC REQUIRED)
find_package(HDF5 1.8 REQUIRED COMPONENTS CXX)

if(HDF5_VERSION VERSION_GREATER 1.8)
  message(WARNING "HDF5 will be used such that it is compatible with version 1.8.")
endif()

# https://github.com/votca/xtp/issues/436, hdf5-1.10.4 generates a implicitly-declared operator warning
if(HDF5_VERSION VERSION_GREATER_EQUAL 1.10.4 AND HDF5_VERSION VERSION_LESS_EQUAL 1.10.6)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-Wno-deprecated-copy" COMPILER_SUPPORTS_WNO_DEPRECATED_COPY)
  if(COMPILER_SUPPORTS_WNO_DEPRECATED_COPY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-copy")
  endif()
endif()

option(BUILD_SHARED_LIBS "Build shared libs" ON)
include(GNUInstallDirs)

option(USE_CUDA "Use a Nvidia GPU to speed up computations" OFF)

option(ENABLE_TESTING "Build and enable testing stuff" OFF)
if(ENABLE_TESTING)
  enable_testing()
endif(ENABLE_TESTING)

########################################################################
#Find external packages
########################################################################
if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)
  find_package(Git)
endif(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)

find_package(Boost 1.57.0 REQUIRED COMPONENTS program_options filesystem system timer)
find_package(Eigen3 3.3.0 REQUIRED NO_MODULE)
message(STATUS "Found Eigen3: ${Eigen3_DIR}")

option(BUILD_MANPAGES "Build manpages (might lead to problem on system without rpath" OFF)
#define this target here, so that individual man pages can append to it.
if(NOT TARGET manpages)
  add_custom_target(manpages ALL)
endif()

find_package(VOTCA_TOOLS REQUIRED NO_MODULE)
if(DEFINED VOTCA_TOOLS_VERSION AND NOT VOTCA_TOOLS_VERSION STREQUAL PROJECT_VERSION)
  message(FATAL_ERROR "Incompatible VOTCA Tools version found (needed ${PROJECT_VERSION}, found ${VOTCA_TOOLS_VERSION})")
endif()
message(STATUS "Found VOTCA_TOOLS: ${VOTCA_TOOLS_DIR}")
find_package(VOTCA_CSG REQUIRED NO_MODULE)
if(DEFINED VOTCA_CSG_VERSION AND NOT VOTCA_CSG_VERSION STREQUAL PROJECT_VERSION)
  message(FATAL_ERROR "Incompatible VOTCA CSG version found (needed ${PROJECT_VERSION}, found ${VOTCA_CSG_VERSION})")
endif()
message(STATUS "Found VOTCA_CSG: ${VOTCA_CSG_DIR}")

if(USE_CUDA)
  find_package(CUDA REQUIRED)
endif(USE_CUDA)

########################################################################
# Checks what linear algebra packages are installed                    #
########################################################################



########################################################################
# Basic system tests (standard libraries, headers, functions, types)   #
########################################################################
include(CheckIncludeFile)
foreach(HEADER assert.h)
  check_include_file(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

include(CheckIncludeFileCXX)
foreach(HEADER algorithm)
  check_include_file_cxx(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

set(MATH_LIBRARIES "m" CACHE STRING "math library")
mark_as_advanced( MATH_LIBRARIES )
include(CheckLibraryExists)
foreach(FUNC sqrt)
  check_library_exists(${MATH_LIBRARIES} ${FUNC} "" FOUND_${FUNC}_${MATH_LIBRARIES})
  if(NOT FOUND_${FUNC}_${MATH_LIBRARIES})
    message(FATAL_ERROR "Could not find needed math function - ${FUNC}")
  endif(NOT FOUND_${FUNC}_${MATH_LIBRARIES})
endforeach(FUNC)

######################################
# Include the following subdirectory #
######################################
add_subdirectory(include/votca/xtp)
add_subdirectory(scripts)
add_subdirectory(src)
add_subdirectory(share)

=== scripts/CMakeLists.txt ===
foreach(SCRIPT xtp_update_mapfile xtp_basisset xtp_makeauxbasis)
  configure_file(${SCRIPT}.in ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.out @ONLY)
  add_custom_target(${SCRIPT}_build ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT})
  add_custom_command(OUTPUT ${SCRIPT} COMMAND ${CMAKE_COMMAND}
    -DINPUT="${SCRIPT}.out" -DOUTPUT="${SCRIPT}"
    -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
    -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}" -P ${CMAKE_MODULE_PATH}/gitscript.cmake)
  set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT})
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR})
endforeach(SCRIPT)

=== share/CMakeLists.txt ===
add_subdirectory(xtp/xml)
add_subdirectory(man)
add_subdirectory(basis_sets)
add_subdirectory(ecps)
add_subdirectory(packages)
add_subdirectory(benchmark)

=== share/benchmark/CMakeLists.txt ===
file(GLOB_RECURSE VOTCA_XTP_XML *.xml)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/xtp/benchmark
	PATTERN "*.in" EXCLUDE
	PATTERN "CMake*" EXCLUDE)

foreach(SCRIPT xtp_benchmark)
  configure_file(${SCRIPT}.in ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.out @ONLY)
  add_custom_target(${SCRIPT}_build ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT})
  add_custom_command(OUTPUT ${SCRIPT} COMMAND ${CMAKE_COMMAND}
    -DINPUT="${SCRIPT}.out" -DOUTPUT="${SCRIPT}"
    -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
    -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}" -P ${CMAKE_MODULE_PATH}/gitscript.cmake)
  set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT})
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT} DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/xtp/benchmark/)
endforeach(SCRIPT)

=== share/man/CMakeLists.txt ===
if (BUILD_MANPAGES)
endif (BUILD_MANPAGES)

=== share/packages/CMakeLists.txt ===
file(GLOB_RECURSE VOTCA_XTP_XML *.xml)
install(FILES ${VOTCA_XTP_XML} DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/xtp/packages/)

=== src/libxtp/CMakeLists.txt ===
add_custom_target(gitversion-xtp COMMAND ${CMAKE_COMMAND} -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
  -P ${CMAKE_MODULE_PATH}/gitversion.cmake)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES gitversion.h)

file(GLOB_RECURSE VOTCA_SOURCES *.cc *.cpp)
file(GLOB_RECURSE NOT_VOTCA_SOURCES cudapipeline.cc cudamatrix.cc)
list(REMOVE_ITEM VOTCA_SOURCES ${NOT_VOTCA_SOURCES})

add_library(votca_xtp  ${VOTCA_SOURCES})
set_target_properties(votca_xtp PROPERTIES SOVERSION ${SOVERSION})
add_dependencies(votca_xtp gitversion-xtp)
target_link_libraries(votca_xtp PUBLIC VOTCA::votca_csg VOTCA::votca_tools Boost::boost Eigen3::Eigen ${HDF5_LIBRARIES} PRIVATE LIBXC::LIBXC Boost::program_options Boost::filesystem Boost::system Boost::timer )

if(USE_CUDA)
  target_link_libraries(votca_xtp PUBLIC ${CUDA_LIBRARIES} ${CUDA_CUBLAS_LIBRARIES})
  target_include_directories(votca_xtp PUBLIC ${CUDA_INCLUDE_DIRS})
  target_sources(votca_xtp PRIVATE cudapipeline.cc cudamatrix.cc)
endif()

#CMAKE_CURRENT_BINARY_DIR for gitversion.h
#PROJECT_BINARY_DIR/include for votca_config.h
target_include_directories(votca_xtp PRIVATE ${CMAKE_CURRENT_BINARY_DIR}
  PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include> ${HDF5_INCLUDE_DIRS}
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
install(TARGETS votca_xtp LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/tests/CMakeLists.txt ===
if(ENABLE_TESTING)  
  # Please place additional tests in alphabetical order
  find_package(Boost 1.57.0 REQUIRED COMPONENTS unit_test_framework)
  option(ENABLE_HIGH_MEMORY_TESTS "Build and run tests, which needs lot of memory" ON)
  list(APPEND test_cases test_adiis)
  list(APPEND test_cases test_aobasis)
  list(APPEND test_cases test_aomatrix)
  list(APPEND test_cases test_aomatrix3d)
  list(APPEND test_cases test_aotransform)
  list(APPEND test_cases test_aopotential)
  list(APPEND test_cases test_atom)
  list(APPEND test_cases test_qmatom)
  list(APPEND test_cases test_polarsegment)
  list(APPEND test_cases test_qmmolecule)
  list(APPEND test_cases test_basisset)
  list(APPEND test_cases test_bfgs-trm)
  list(APPEND test_cases test_bse)
  list(APPEND test_cases test_convergenceacc)
  list(APPEND test_cases test_dftcoupling)
  list(APPEND test_cases test_diis)
  list(APPEND test_cases test_eigen)
  list(APPEND test_cases test_eris)
  list(APPEND test_cases test_espfit)
  list(APPEND test_cases test_glink)
  list(APPEND test_cases test_hdf5)
  list(APPEND test_cases test_cubefile_writer)
  list(APPEND test_cases test_densityintegration)
  list(APPEND test_cases test_vxc_potential)
  list(APPEND test_cases test_vxc_grid)
  list(APPEND test_cases test_regular_grid)
  list(APPEND test_cases test_orbitals)
  list(APPEND test_cases test_polarsite)
  list(APPEND test_cases test_ppm)
  list(APPEND test_cases test_qmnblist)
  list(APPEND test_cases test_qmpair)
  list(APPEND test_cases test_qmstate)
  list(APPEND test_cases test_radial_euler_maclaurin_rule)
  list(APPEND test_cases test_rpa)
  list(APPEND test_cases test_rpa_h2p)
  list(APPEND test_cases test_segment)
  list(APPEND test_cases test_aoshell)
  if(ENABLE_HIGH_MEMORY_TESTS)
    list(APPEND test_cases test_sphere_lebedev_rule)
  endif()
  list(APPEND test_cases test_sphere_lebedev_rule_fine)
  list(APPEND test_cases test_sphere_lebedev_rule_xfine)
  list(APPEND test_cases test_statetracker)
  list(APPEND test_cases test_symmetric_matrix)
  list(APPEND test_cases test_threecenter_dft)
  list(APPEND test_cases test_threecenter_gwbse)
  list(APPEND test_cases test_topology)
  list(APPEND test_cases test_sigma_exact)
  list(APPEND test_cases test_sigma_ppm)
  list(APPEND test_cases test_gw)
  list(APPEND test_cases test_bse_operator)
  list(APPEND test_cases test_davidson)
  list(APPEND test_cases test_trustregion)
  list(APPEND test_cases test_gnode)
  list(APPEND test_cases test_vc2index)
  list(APPEND test_cases test_grid)
  list(APPEND test_cases test_segmentmapper)
  list(APPEND test_cases test_eeinteractor)
  list(APPEND test_cases test_hist)
  list(APPEND test_cases test_qmfragment)
  list(APPEND test_cases test_jobtopology)
  list(APPEND test_cases test_dipoledipoleinteraction)
  list(APPEND test_cases test_populationanalysis)
  list(APPEND test_cases test_gaussian)
  list(APPEND test_cases test_orca)
  list(APPEND test_cases test_nwchem)
  list(APPEND test_cases test_dftengine)
  list(APPEND test_cases test_bsecoupling)
  list(APPEND test_cases test_rate_engine)
  list(APPEND test_cases test_fourcenter)  
  list(APPEND test_cases test_DeltaQ_filter)
  list(APPEND test_cases test_oscillatorstrength_filter)
  list(APPEND test_cases test_localisation_filter)
  list(APPEND test_cases test_density_filter)
  list(APPEND test_cases test_overlap_filter)
  list(APPEND test_cases test_newton_rapson)
  list(APPEND test_cases test_indexparser)
  if(USE_CUDA)
    list(APPEND test_cases test_cudapipeline)
    list(APPEND test_cases test_cudamatrix)    
  endif()

  foreach(PROG ${test_cases} )
    add_executable(unit_${PROG} ${PROG}.cc)
    target_link_libraries(unit_${PROG} votca_xtp Boost::unit_test_framework)
    target_compile_definitions(unit_${PROG} PRIVATE BOOST_TEST_DYN_LINK)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Run_unit_${PROG})
    add_test(NAME unit_${PROG} COMMAND $<TARGET_FILE:unit_${PROG}> WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Run_unit_${PROG})
    # run tests for xtp (for coverage) as well
    set_tests_properties(unit_${PROG} PROPERTIES LABELS "xtp;votca;unit")
  endforeach(PROG)
endif()

=== src/tools/CMakeLists.txt ===
foreach(PROG xtp_map xtp_run xtp_tools xtp_parallel xtp_dump)
  file(GLOB ${PROG}_SOURCES ${PROG}*.cc)
  add_executable(${PROG} ${${PROG}_SOURCES})
  target_link_libraries(${PROG} votca_xtp)
  install(TARGETS ${PROG} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

  if (BUILD_MANPAGES)
     add_custom_command(OUTPUT ${PROG}.man
       COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${PROG} --man > ${PROG}.man
       COMMENT "Building ${PROG} manpage"
       DEPENDS ${PROG})
     add_custom_target(${PROG}_manpage DEPENDS ${PROG}.man)
     add_dependencies(manpages ${PROG}_manpage)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROG}.man DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 RENAME ${PROG}.1)
  endif (BUILD_MANPAGES)

  if(ENABLE_TESTING)
    add_test(integration_${PROG}Help ${PROG} --help)
    # run tests for tools, csg, ctp as well for coverage
    set_tests_properties(integration_${PROG}Help PROPERTIES LABELS "xtp;tools;csg;ctp;votca;integration")
  endif(ENABLE_TESTING)
endforeach(PROG)

=== include/votca/xtp/CMakeLists.txt ===
configure_file(votca_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h)

file(GLOB_RECURSE VOTCA_HEADERS *.h ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h)
install(FILES ${VOTCA_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/votca/xtp)

=== debian/changelog ===
votca-xtp (1.6.4-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Breen <nbreen@debian.org>  Thu, 28 Jan 2021 21:45:40 -0800

votca-xtp (1.6.3-1) unstable; urgency=medium

  * New upstream release.
  * Make cross Build-Depends satisfiably annotate python3 with :any.
  * Update Standards-Version to 4.5.1, no changes required. 

 -- Nicholas Breen <nbreen@debian.org>  Sun, 13 Dec 2020 10:59:37 -0800

votca-xtp (1.6.2-2) unstable; urgency=medium

  * Fix typo in Suggests: on votca-xtp-tutorials.
  * Mark votca-xtp-tutorials as Multi-Arch: foreign.
  * Update Standards-Version to 4.5.1, no changes needed.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 05 Dec 2020 17:56:10 -0800

votca-xtp (1.6.2-1) unstable; urgency=medium

  * New upstream release. 

 -- Nicholas Breen <nbreen@debian.org>  Sat, 17 Oct 2020 16:03:03 -0700

votca-xtp (1.6.1-1) unstable; urgency=medium

  * Initial release. (Closes: #921202)

 -- Nicholas Breen <nbreen@debian.org>  Sat, 18 Jul 2020 08:36:08 -0700

=== debian/control ===
Source: votca-xtp
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Nicholas Breen <nbreen@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libboost-chrono-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-timer-dev,
               libceres-dev,
               libeigen3-dev,
               libfftw3-dev,
               libhdf5-dev,
               libsqlite3-dev,
               libvotca-csg-dev (>= 1.6.4),
               libvotca-csg-dev (<< 1.7~),
               libvotca-tools-dev (>= 1.6.4),
               libvotca-tools-dev (<< 1.7~),
               libxc-dev,
               pkg-config,
               python3:any,
               votca-csg (>= 1.6.3)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://www.votca.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/votca-xtp
Vcs-Git: https://salsa.debian.org/debichem-team/votca-xtp.git

Package: libvotca-xtp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libvotca-xtp6 (= ${binary:Version}), ${misc:Depends}
Description: VOTCA's exciton transport library, development kit
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 libvotca-xtp is VOTCA's exciton transport simulation library.  This package
 contains header files and pkg-config files for programs using VOTCA.

Package: libvotca-xtp6
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: VOTCA's exciton transport library
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 libvotca-xtp is VOTCA's exciton transport simulation library.

Package: votca-xtp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Suggests: votca-xtp-tutorials
Description: VOTCA's exciton transport engine
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 xtp is Votca's exciton transport simulation engine.

Package: votca-xtp-tutorials
Architecture: all
Multi-Arch: foreign
Depends: bash (>= 4), ${misc:Depends}
Recommends: votca-xtp, python3:any
Description: VOTCA's coarse-graining tutorials
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 This package contains architecture-independent tutorials for votca-xtp.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export CTEST_OUTPUT_ON_FAILURE = On

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTING=On -DBUILD_MANPAGES=On

# Some tests are unstable.  Run them, but don't fail on them just yet.
override_dh_auto_test:
	-dh_auto_test

override_dh_auto_install:
	dh_auto_install
	cp -r tutorials debian/tmp/usr/share/votca/tutorials-xtp
	find debian/tmp/usr/share/votca/tutorials-xtp \( -name .gitignore -o -name .gitlab-ci.yml -o -name .travis.yml \) -exec rm {} \;
	find debian/tmp/usr/share/votca/tutorials-xtp -name system.com -exec chmod a-x {} \;
	-rm -rf debian/tmp/usr/share/votca/tutorials-xtp/CMakeModules debian/tmp/usr/share/votca/tutorials-xtp/CMakeLists.txt

override_dh_installman:
	dh_installman --sourcedir=$(CURDIR)/debian/man

%:
	dh $@ --with python3

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/votca-xtp-$1\.tar\.gz/ \
https://github.com/votca/xtp/releases .*/archive/v([\d.]+)\.tar\.(?:bz2|gz)
opts="component=tutorials,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/votca-xtp-tutorials-$1\.tar\.gz/" \
https://github.com/votca/xtp-tutorials/releases .*/archive/v([\d.]+)\.tar\.(?:bz2|gz)

## votca-xtp 2021.1

=== debian/changelog ===
votca-xtp (2021.1-2) unstable; urgency=medium

  * Adjust CXXFLAGS on mipsel to reduce memory pressure while compiling,
    working around a FTBFS.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 21 Aug 2021 20:37:02 -0700

votca-xtp (2021.1-1) unstable; urgency=medium

  * New upstream release.  Upload to unstable, after release.
  * Bump Standards-Version to 4.6.0, no changes required.

 -- Nicholas Breen <nbreen@debian.org>  Thu, 19 Aug 2021 19:47:31 -0700

votca-xtp (2021-1) experimental; urgency=medium

  * New upstream release.  Upload to experimental during freeze.
    - Add Build-Depends: libint2-dev.
  * SONAME bump to 2021 - now matches major version of project.
  * Override blhc false-positives.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 19 Jun 2021 17:01:37 -0700

=== debian/control ===
--- 
+++ 
@@ -17,16 +17,17 @@
                libeigen3-dev,
                libfftw3-dev,
                libhdf5-dev,
+               libint2-dev,
                libsqlite3-dev,
-               libvotca-csg-dev (>= 1.6.4),
-               libvotca-csg-dev (<< 1.7~),
-               libvotca-tools-dev (>= 1.6.4),
-               libvotca-tools-dev (<< 1.7~),
+               libvotca-csg-dev (>= 2021),
+               libvotca-csg-dev (<< 2022~),
+               libvotca-tools-dev (>= 2021),
+               libvotca-tools-dev (<< 2022~),
                libxc-dev,
                pkg-config,
                python3:any,
-               votca-csg (>= 1.6.3)
-Standards-Version: 4.5.1
+               votca-csg (>= 2021)
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://www.votca.org/
 Vcs-Browser: https://salsa.debian.org/debichem-team/votca-xtp
@@ -36,7 +37,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libvotca-xtp6 (= ${binary:Version}), ${misc:Depends}
+Depends: libvotca-xtp2021 (= ${binary:Version}), ${misc:Depends}
 Description: VOTCA's exciton transport library, development kit
  VOTCA is a software package which focuses on the analysis of molecular
  dynamics data, the development of systematic coarse-graining techniques as
@@ -46,7 +47,7 @@
  libvotca-xtp is VOTCA's exciton transport simulation library.  This package
  contains header files and pkg-config files for programs using VOTCA.
 
-Package: libvotca-xtp6
+Package: libvotca-xtp2021
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,15 @@
 
 export CTEST_OUTPUT_ON_FAILURE = On
 
+# Reduce memory pressure while compiling on mipsel.
+ifneq (,$(filter $(DEB_HOST_ARCH), mipsel))
+	export DEB_CXXFLAGS_MAINT_APPEND += -O1 -g1 -DNDEBUG
+endif
+
 override_dh_auto_configure:
 	dh_auto_configure -- -DENABLE_TESTING=On -DBUILD_MANPAGES=On
+	@echo 'blhc: ignore-line-regexp: \s+C\+\+ vector data structures'
+	@echo 'blhc: ignore-line-regexp: .*Building CXX object src/libxtp/CMakeFiles/votca_xtp.dir/IndexParser.cc.o'
 
 # Some tests are unstable.  Run them, but don't fail on them just yet.
 override_dh_auto_test:

## votca-xtp 2021.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(votca-xtp LANGUAGES CXX)

set(PROJECT_VERSION "2021.2")
string(REGEX REPLACE "[-.].*$" "" SOVERSION "${PROJECT_VERSION}")
if (NOT ${SOVERSION} MATCHES "^[0-9]+$")
  message(FATAL_ERROR "Could not determine SOVERSION (${SOVERSION}) from ${PROJECT_VERSION}")
endif (NOT ${SOVERSION} MATCHES "^[0-9]+$")
set(PROJECT_CONTACT "https://github.com/votca/xtp/issues")

# Cmake modules/macros are in a subdirectory to keep this file cleaner
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
  #Release comes with -O3 by default
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
if(CMAKE_BUILD_TYPE STREQUAL Debug)
  add_definitions(-DDEBUG)
endif()

######################################################################
# compiler tests
# these need ot be done early (before further tests).
#####################################################################

include(FeatureSummary)
include(CheckCXXCompilerFlag)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF) #...without compiler extensions like gnu++11

#openmp with clang smaller version 10 and user defined reductions is buggy https://bugs.llvm.org/show_bug.cgi?id=44134
if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 10.0)
  find_package(OpenMP 4.5)
  set_package_properties(OpenMP PROPERTIES TYPE RECOMMENDED PURPOSE "Used for thread parallelization in xtp")
else()
  # in case OpenMP was detected somewhere else
  unset(OpenMP_FOUND)
endif()

########################################################################
# User input options                                                   #
########################################################################


find_package(PkgConfig REQUIRED)
set_package_properties(PkgConfig PROPERTIES TYPE RECOMMENDED PURPOSE "Used to detect libxc and libint package")
pkg_check_modules(LIBXC REQUIRED IMPORTED_TARGET libxc)
if(NOT TARGET PkgConfig::LIBINT)
  pkg_check_modules(LIBINT REQUIRED IMPORTED_TARGET libint2>=2.6)
endif()

find_package(HDF5 1.8 REQUIRED COMPONENTS CXX)
set_package_properties(HDF5 PROPERTIES TYPE REQUIRED PURPOSE "Used to read/write HDF5 data files")

if(HDF5_VERSION VERSION_GREATER 1.8)
  message(WARNING "HDF5 will be used such that it is compatible with version 1.8.")
endif()

# https://github.com/votca/xtp/issues/436, hdf5-1.10.4 generates a implicitly-declared operator warning
if(HDF5_VERSION VERSION_GREATER_EQUAL 1.10.4 AND HDF5_VERSION VERSION_LESS_EQUAL 1.10.6)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-Wno-deprecated-copy" COMPILER_SUPPORTS_WNO_DEPRECATED_COPY)
  if(COMPILER_SUPPORTS_WNO_DEPRECATED_COPY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-copy")
  endif()
endif()

option(BUILD_SHARED_LIBS "Build shared libs" ON)
include(GNUInstallDirs)

option(USE_CUDA "Use a Nvidia GPU to speed up computations" OFF)
add_feature_info(USE_CUDA USE_CUDA "Use CUDA for GPU acceleration")

option(ENABLE_TESTING "Build and enable testing stuff" OFF)
add_feature_info(ENABLE_TESTING ENABLE_TESTING "Enable unit tests")
if(ENABLE_TESTING)
  enable_testing()
endif(ENABLE_TESTING)

########################################################################
#Find external packages
########################################################################
if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)
  find_package(Git)
  set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Generated version for development version")
endif(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)

find_package(Boost 1.57.0 REQUIRED COMPONENTS program_options filesystem system timer)
find_package(Eigen3 3.3.0 REQUIRED NO_MODULE)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set_package_properties(Boost PROPERTIES TYPE REQUIRED PURPOSE "Extended C++ libraries")
  set_package_properties(Eigen3 PROPERTIES TYPE REQUIRED PURPOSE "C++ vector data structures")
endif()
message(STATUS "Found Eigen3: ${Eigen3_DIR}")

option(BUILD_MANPAGES "Build manpages (might lead to problem on system without rpath" OFF)
add_feature_info(BUILD_MANPAGES BUILD_MANPAGES "Build manpages (disable for cross-compile)")
#define this target here, so that individual man pages can append to it.
if(NOT TARGET manpages)
  add_custom_target(manpages ALL)
endif()

find_package(VOTCA_TOOLS REQUIRED NO_MODULE)
set_package_properties(VOTCA_TOOLS PROPERTIES TYPE REQUIRED PURPOSE "Votca base library")
if(DEFINED VOTCA_TOOLS_VERSION AND NOT VOTCA_TOOLS_VERSION STREQUAL PROJECT_VERSION)
  message(FATAL_ERROR "Incompatible VOTCA Tools version found (needed ${PROJECT_VERSION}, found ${VOTCA_TOOLS_VERSION})")
endif()
message(STATUS "Found VOTCA_TOOLS: ${VOTCA_TOOLS_DIR}")
find_package(VOTCA_CSG REQUIRED NO_MODULE)
set_package_properties(VOTCA_TOOLS PROPERTIES TYPE REQUIRED PURPOSE "Votca csg library")
if(DEFINED VOTCA_CSG_VERSION AND NOT VOTCA_CSG_VERSION STREQUAL PROJECT_VERSION)
  message(FATAL_ERROR "Incompatible VOTCA CSG version found (needed ${PROJECT_VERSION}, found ${VOTCA_CSG_VERSION})")
endif()
message(STATUS "Found VOTCA_CSG: ${VOTCA_CSG_DIR}")

if(USE_CUDA)
  find_package(CUDA REQUIRED)
  set_package_properties(CUDA PROPERTIES TYPE REQUIRED PURPOSE "Used for GPU acceleration")
endif(USE_CUDA)

########################################################################
# Checks what linear algebra packages are installed                    #
########################################################################



########################################################################
# Basic system tests (standard libraries, headers, functions, types)   #
########################################################################
include(CheckIncludeFileCXX)
foreach(HEADER algorithm)
  check_include_file_cxx(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

set(MATH_LIBRARIES "m" CACHE STRING "math library")
mark_as_advanced( MATH_LIBRARIES )

######################################
# Include the following subdirectory #
######################################
add_subdirectory(include/votca/xtp)
add_subdirectory(scripts)
add_subdirectory(src)
add_subdirectory(share)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  feature_summary(INCLUDE_QUIET_PACKAGES WHAT ALL)
endif (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)

=== scripts/CMakeLists.txt ===
foreach(SCRIPT xtp_update_mapfile xtp_basisset xtp_makeauxbasis xtp_autogen_mapping xtp_qmmm2qm)
  configure_file(${SCRIPT}.in ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.out @ONLY)
  add_custom_target(${SCRIPT}_build ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT})
  add_custom_command(OUTPUT ${SCRIPT} COMMAND ${CMAKE_COMMAND}
    -DINPUT="${SCRIPT}.out" -DOUTPUT="${SCRIPT}"
    -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
    -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}" -P ${PROJECT_SOURCE_DIR}/CMakeModules/gitscript.cmake)
  set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT})
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR})
endforeach(SCRIPT)

=== share/CMakeLists.txt ===
add_subdirectory(xtp/basis_sets)
add_subdirectory(xtp/data)
add_subdirectory(xtp/xml)
add_subdirectory(xtp/ecps)
add_subdirectory(benchmark)
add_subdirectory(doc)

=== src/CMakeLists.txt ===
add_subdirectory(libxtp)
add_subdirectory(tools)
if(ENABLE_TESTING)
  add_subdirectory(tests)
endif()

=== share/doc/CMakeLists.txt ===
if(VOTCA_SPHINX_DIR)
  file(GLOB RSTS ${CMAKE_CURRENT_SOURCE_DIR}/*.rst)
  set(MANUAL_RST_FILES)
  foreach(_RST ${RSTS})
    get_filename_component(_FILE "${_RST}" NAME)
    add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${_RST} ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE}
      DEPENDS ${_RST})
    list(APPEND MANUAL_RST_FILES ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE})
  endforeach()

  set(NOTEBOOKS "GROMACS/Methane/QMMM_GROMACS.ipynb")
  list(APPEND NOTEBOOKS "LAMMPS/Thiophene/QMMM_LAMMPS.ipynb")
  list(APPEND NOTEBOOKS "tools/dftgwbse_CH4/DFTGWBSE_ENERGY.ipynb")
  list(APPEND NOTEBOOKS "tools/dftgwbse_CO_geoopt/DFTGWBSE_OPTIMIZATION.ipynb")
  # list(APPEND NOTEBOOKS "GROMACS/KMC_Methane/GROMACS_KMC.ipynb")
  list(APPEND NOTEBOOKS "LAMMPS/KMC_Thiophene/LAMMPS_KMC.ipynb")
  
  find_package(JUPYTER_NBCONVERT 5.4.1)
  find_package(SPHINX 2.1)
  set(NEW_NOTEBOOKS)
  
  if(JUPYTER_NBCONVERT_FOUND AND SPHINX_FOUND)
    enable_language(CXX) # to detect xtp
    find_package(VOTCA_XTP REQUIRED NO_MODULE)
    set_package_properties(VOTCA_XTP PROPERTIES TYPE REQUIRED PURPOSE "Votca xtp library")
    if(DEFINED VOTCA_XTP_VERSION AND NOT VOTCA_XTP_VERSION STREQUAL PROJECT_VERSION)
      message(FATAL_ERROR "Incompatible VOTCA XTP version found (needed ${PROJECT_VERSION}, found ${VOTCA_XTP_VERSION})")
    endif()
    message(STATUS "Found VOTCA_XTP: ${VOTCA_XTP_DIR}")
  
    get_target_property(XTP_PATH VOTCA::votca_xtp XTP_PATH)
    get_target_property(VOTCASHARE VOTCA::votca_xtp VOTCA_SHARE)
    foreach(_notebook ${NOTEBOOKS})
      get_filename_component(_FILE "${_notebook}" NAME)
      get_filename_component(_DIR "${_notebook}" DIRECTORY)
      file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_DIR})
      file(MAKE_DIRECTORY ${VOTCA_SPHINX_DIR}/xtp-tutorials)
      file(GLOB FILES ${PROJECT_SOURCE_DIR}/${_DIR}/*)
      add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE}
        COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_SOURCE_DIR}/${_DIR} ${CMAKE_CURRENT_BINARY_DIR}/${_DIR}
        COMMAND ${CMAKE_COMMAND} -E env PATH=${XTP_PATH}:$ENV{PATH} VOTCASHARE=${VOTCASHARE} ${JUPYTER_EXECUTABLE} nbconvert --to notebook --ExecutePreprocessor.timeout=5000 --execute ${_FILE} --output ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_DIR}
	DEPENDS ${FILES}
      )
      list(APPEND NEW_NOTEBOOKS ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE})
    endforeach()
  else()
    foreach(_DEP ${NOTEBOOKS})
      get_filename_component(_FILE "${_DEP}" NAME)
      add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE}
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${PROJECT_SOURCE_DIR}/${_DEP} ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE} DEPENDS ${PROJECT_SOURCE_DIR}/${_DEP}
  )
      list(APPEND NEW_NOTEBOOKS ${VOTCA_SPHINX_DIR}/xtp-tutorials/${_FILE})
      endforeach()
  endif()
  
  add_custom_target(doc-xtp-tutorials DEPENDS ${NEW_NOTEBOOKS} ${MANUAL_RST_FILES})
endif()

=== src/libxtp/CMakeLists.txt ===
add_custom_target(gitversion-xtp COMMAND ${CMAKE_COMMAND} -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
  -P ${PROJECT_SOURCE_DIR}/CMakeModules/gitversion.cmake)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES gitversion.h)

file(GLOB_RECURSE VOTCA_SOURCES *.cc *.cpp)
file(GLOB_RECURSE NOT_VOTCA_SOURCES cudapipeline.cc cudamatrix.cc)
list(REMOVE_ITEM VOTCA_SOURCES ${NOT_VOTCA_SOURCES})

get_filename_component(_PARENT_PATH "${CMAKE_CURRENT_BINARY_DIR}" DIRECTORY)

add_library(votca_xtp  ${VOTCA_SOURCES})
set_target_properties(votca_xtp PROPERTIES SOVERSION ${SOVERSION})
set_target_properties(votca_xtp PROPERTIES VOTCA_SHARE ${PROJECT_SOURCE_DIR}/share)
set_target_properties(votca_xtp PROPERTIES XTP_PATH ${_PARENT_PATH}/tools)
add_dependencies(votca_xtp gitversion-xtp)
target_link_libraries(votca_xtp PUBLIC VOTCA::votca_csg VOTCA::votca_tools Boost::boost Eigen3::Eigen ${HDF5_LIBRARIES} PRIVATE PkgConfig::LIBXC PkgConfig::LIBINT Boost::program_options Boost::filesystem Boost::system Boost::timer )

if(OpenMP_FOUND)
  target_link_libraries(votca_xtp PUBLIC OpenMP::OpenMP_CXX)
endif()

if(USE_CUDA)
  target_link_libraries(votca_xtp PUBLIC ${CUDA_LIBRARIES} ${CUDA_CUBLAS_LIBRARIES})
  target_include_directories(votca_xtp PUBLIC ${CUDA_INCLUDE_DIRS})
  target_sources(votca_xtp PRIVATE cudapipeline.cc cudamatrix.cc)
endif()

#CMAKE_CURRENT_BINARY_DIR for gitversion.h
#PROJECT_BINARY_DIR/include/votca/xtp for votca_xtp_config.h
target_include_directories(votca_xtp PRIVATE ${CMAKE_CURRENT_BINARY_DIR}
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include> ${HDF5_INCLUDE_DIRS}
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/votca/xtp>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
install(TARGETS votca_xtp EXPORT VOTCA_XTP_Targets
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT VOTCA_XTP_Targets FILE VOTCA_XTP_Targets.cmake NAMESPACE VOTCA:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VOTCA_XTP)

include(CMakePackageConfigHelpers)
write_basic_package_version_file("VOTCA_XTPConfigVersion.cmake" VERSION ${PROJECT_VERSION} COMPATIBILITY ExactVersion)
configure_file(VOTCA_XTPConfig.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_XTPConfig.cmake" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_XTPConfig.cmake" "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_XTPConfigVersion.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VOTCA_XTP)
add_library(VOTCA::votca_xtp ALIAS votca_xtp)

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,6 @@
-if(ENABLE_TESTING)  
+if(ENABLE_TESTING)
   # Please place additional tests in alphabetical order
   find_package(Boost 1.57.0 REQUIRED COMPONENTS unit_test_framework)
-  option(ENABLE_HIGH_MEMORY_TESTS "Build and run tests, which needs lot of memory" ON)
   list(APPEND test_cases test_adiis)
   list(APPEND test_cases test_aobasis)
   list(APPEND test_cases test_aomatrix)
@@ -13,11 +12,12 @@
   list(APPEND test_cases test_polarsegment)
   list(APPEND test_cases test_qmmolecule)
   list(APPEND test_cases test_basisset)
-  list(APPEND test_cases test_bfgs-trm)
+  list(APPEND test_cases test_bfgs_trm)
   list(APPEND test_cases test_bse)
   list(APPEND test_cases test_convergenceacc)
   list(APPEND test_cases test_dftcoupling)
   list(APPEND test_cases test_diis)
+  list(APPEND test_cases test_ecpaobasis)
   list(APPEND test_cases test_eigen)
   list(APPEND test_cases test_eris)
   list(APPEND test_cases test_espfit)
@@ -30,6 +30,7 @@
   list(APPEND test_cases test_regular_grid)
   list(APPEND test_cases test_orbitals)
   list(APPEND test_cases test_polarsite)
+  list(APPEND test_cases test_staticsite)
   list(APPEND test_cases test_ppm)
   list(APPEND test_cases test_qmnblist)
   list(APPEND test_cases test_qmpair)
@@ -39,11 +40,7 @@
   list(APPEND test_cases test_rpa_h2p)
   list(APPEND test_cases test_segment)
   list(APPEND test_cases test_aoshell)
-  if(ENABLE_HIGH_MEMORY_TESTS)
-    list(APPEND test_cases test_sphere_lebedev_rule)
-  endif()
-  list(APPEND test_cases test_sphere_lebedev_rule_fine)
-  list(APPEND test_cases test_sphere_lebedev_rule_xfine)
+  list(APPEND test_cases test_sphere_lebedev_rule)
   list(APPEND test_cases test_statetracker)
   list(APPEND test_cases test_symmetric_matrix)
   list(APPEND test_cases test_threecenter_dft)
@@ -51,6 +48,7 @@
   list(APPEND test_cases test_topology)
   list(APPEND test_cases test_sigma_exact)
   list(APPEND test_cases test_sigma_ppm)
+  list(APPEND test_cases test_sigma_cda)
   list(APPEND test_cases test_gw)
   list(APPEND test_cases test_bse_operator)
   list(APPEND test_cases test_davidson)
@@ -65,13 +63,10 @@
   list(APPEND test_cases test_jobtopology)
   list(APPEND test_cases test_dipoledipoleinteraction)
   list(APPEND test_cases test_populationanalysis)
-  list(APPEND test_cases test_gaussian)
   list(APPEND test_cases test_orca)
-  list(APPEND test_cases test_nwchem)
   list(APPEND test_cases test_dftengine)
   list(APPEND test_cases test_bsecoupling)
   list(APPEND test_cases test_rate_engine)
-  list(APPEND test_cases test_fourcenter)  
   list(APPEND test_cases test_DeltaQ_filter)
   list(APPEND test_cases test_oscillatorstrength_filter)
   list(APPEND test_cases test_localisation_filter)
@@ -79,14 +74,20 @@
   list(APPEND test_cases test_overlap_filter)
   list(APPEND test_cases test_newton_rapson)
   list(APPEND test_cases test_indexparser)
+  list(APPEND test_cases test_settings)
+  list(APPEND test_cases test_orbreorder)
+  list(APPEND test_cases test_molden)
   if(USE_CUDA)
     list(APPEND test_cases test_cudapipeline)
-    list(APPEND test_cases test_cudamatrix)    
+    list(APPEND test_cases test_cudamatrix)
   endif()
+  list(APPEND test_cases test_anderson)
+  list(APPEND test_cases test_gaussian_quadratures)
 
   foreach(PROG ${test_cases} )
     add_executable(unit_${PROG} ${PROG}.cc)
-    target_link_libraries(unit_${PROG} votca_xtp Boost::unit_test_framework)
+    target_compile_definitions(unit_${PROG} PRIVATE XTP_TEST_DATA_FOLDER="${CMAKE_CURRENT_SOURCE_DIR}/DataFiles")
+    target_link_libraries(unit_${PROG} votca_xtp Boost::unit_test_framework PkgConfig::LIBINT)
     target_compile_definitions(unit_${PROG} PRIVATE BOOST_TEST_DYN_LINK)
     file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Run_unit_${PROG})
     add_test(NAME unit_${PROG} COMMAND $<TARGET_FILE:unit_${PROG}> WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Run_unit_${PROG})

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-foreach(PROG xtp_map xtp_run xtp_tools xtp_parallel xtp_dump)
+foreach(PROG xtp_map xtp_run xtp_tools xtp_parallel)
   file(GLOB ${PROG}_SOURCES ${PROG}*.cc)
   add_executable(${PROG} ${${PROG}_SOURCES})
   target_link_libraries(${PROG} votca_xtp)

=== share/xtp/data/CMakeLists.txt ===
file(GLOB_RECURSE VOTCA_XTP_DATA *.xml)
install(FILES ${VOTCA_XTP_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/xtp/data)

=== share/xtp/xml/CMakeLists.txt ===
file(GLOB_RECURSE VOTCA_XTP_XML *.xml)
install(FILES ${VOTCA_XTP_XML} DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/xtp/xml)

=== debian/changelog ===
votca-xtp (2021.2-1ubuntu1) jammy; urgency=medium

  * Set --max-parallel=2 to avoid OOM on amd64, arm64 and ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 06 Jan 2022 07:02:30 +0000

votca-xtp (2021.2-1build1) jammy; urgency=medium

  * No-change rebuild against libxc9

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Jan 2022 11:45:17 +0000

votca-xtp (2021.2-1) unstable; urgency=medium

  * New upstream release.
  * Tighten build dependencies to require matching minor versions of
    votca-tools and -csg, not just major versions.
  * Fail on build time tests, *except* s390x, which has one remaining
    unidentified issue.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 10 Oct 2021 09:32:30 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: votca-xtp
 Section: science
 Priority: optional
-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Nicholas Breen <nbreen@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
@@ -19,17 +20,17 @@
                libhdf5-dev,
                libint2-dev,
                libsqlite3-dev,
-               libvotca-csg-dev (>= 2021),
-               libvotca-csg-dev (<< 2022~),
-               libvotca-tools-dev (>= 2021),
-               libvotca-tools-dev (<< 2022~),
+               libvotca-csg-dev (>= 2021.2),
+               libvotca-csg-dev (<< 2021.3~),
+               libvotca-tools-dev (>= 2021.2),
+               libvotca-tools-dev (<< 2021.3~),
                libxc-dev,
                pkg-config,
                python3:any,
                votca-csg (>= 2021)
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
-Homepage: http://www.votca.org/
+Homepage: https://www.votca.org/
 Vcs-Browser: https://salsa.debian.org/debichem-team/votca-xtp
 Vcs-Git: https://salsa.debian.org/debichem-team/votca-xtp.git

=== debian/rules ===
--- 
+++ 
@@ -16,9 +16,9 @@
 	@echo 'blhc: ignore-line-regexp: \s+C\+\+ vector data structures'
 	@echo 'blhc: ignore-line-regexp: .*Building CXX object src/libxtp/CMakeFiles/votca_xtp.dir/IndexParser.cc.o'
 
-# Some tests are unstable.  Run them, but don't fail on them just yet.
+# One test unstable on s390x only.
 override_dh_auto_test:
-	-dh_auto_test
+	dh_auto_test || dpkg-architecture -i s390x
 
 override_dh_auto_install:
 	dh_auto_install
@@ -31,4 +31,4 @@
 	dh_installman --sourcedir=$(CURDIR)/debian/man
 
 %:
-	dh $@ --with python3
+	dh $@ --max-parallel=2 --with python3

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/votca-xtp-$1\.tar\.gz/ \
https://github.com/votca/xtp/releases .*/archive/refs/tags/v([\d.]+)\.tar\.(?:bz2|gz)
opts="component=tutorials,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/votca-xtp-tutorials-$1\.tar\.gz/" \
https://github.com/votca/xtp-tutorials/releases .*/archive/refs/tags/v([\d.]+)\.tar\.(?:bz2|gz)
